(define-module (ordo context)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-9)
  #:use-module (srfi srfi-26)
  #:export (context
            context?
            context-scratch-dir
            add-context-triggers!
            get-context-triggers
            context-triggered?
            register-context-var!
            resolve-context-refs))

(define-record-type <context>
  (make-context scratch-dir vars)
  context?
  (scratch-dir context-scratch-dir set-context-scratch-dir!)
  (vars context-vars set-context-vars!)
  (triggers context-triggers set-context-triggers!))

(define* (context #:key scratch-dir init-vars)
  (make-context scratch-dir init-vars))

(define-syntax resolve-context-refs
  (syntax-rules ($)
    ((_ ctx ($ x))
     (assoc-ref (context-vars ctx) x))
    ((_ ctx (f x ...))
     (f (resolve-context-refs ctx x) ...))
    ((_ ctx x) x)))

(define (add-context-triggers! ctx triggers)
  (when triggers
    (set-context-triggers! ctx
                           (apply lset-adjoin equal? (or (context-triggers ctx) '()) triggers))))

(define (context-triggered? ctx trigger)
  (find (lambda (t) (equal? t trigger)) (context-triggers ctx)))

(define (register-context-var! ctx var-name val)
  (set-context-vars! ctx (assoc-set! (context-vars ctx) var-name val)))
